



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>BZOJ3451: Tyvj1953 Normal</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">BZOJ3451: Tyvj1953 Normal</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-17 20:03:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题解：</p>
<p>好神的一道题。蒟蒻只能膜拜题解。</p>
<p>考虑a对b的贡献，如果a是a-b路径上第一个删除的点，那么给b贡献1。</p>
<p>所以转化之后就是求sigma(1/dist(i,j)),orz！！！</p>
<p>如果不是分母的话O（n）就可以搞，但是现在在分母上。。。</p>
<p>考虑转化一下，求ret[i]表示距离为i的点对有多少对。我们发现只要求出ret数组，然后就可以回答了。</p>
<p>如何求ret，我们用点分治。类似于RACE那道题。</p>
<p>对于一颗子树，我们整个信息一块统计，让它和前面的所有做卷积，更新ret，然后再把这棵子树归入前面的信息内。</p>
<p>代码：</p>
<div>
<div>
<pre class="prettyprint linenums"> #include&lt;cstdio&gt;

 #include&lt;cstdlib&gt;

 #include&lt;cmath&gt;

 #include&lt;cstring&gt;

 #include&lt;algorithm&gt;

 #include&lt;iostream&gt;

 #include&lt;vector&gt;

 #include&lt;map&gt;

 #include&lt;set&gt;

 #include&lt;queue&gt;

 #include&lt;string&gt;

 #define inf 1000000000

 #define maxn 50000+5

 #define maxm 20000000+5

 #define eps 1e-10

 #define ll long long

 #define pa pair&lt;int,int&gt;

 #define for0(i,n) for(int i=0;i&lt;=(n);i++)

 #define for1(i,n) for(int i=1;i&lt;=(n);i++)

 #define for2(i,x,y) for(int i=(x);i&lt;=(y);i++)

 #define for3(i,x,y) for(int i=(x);i&gt;=(y);i--)<br />
 #define for4(i,x) for(int i=head[x],y;i;i=e[i].next)

 #define mod 1000000007

 using namespace std;

 inline int read()

 {

     int x=,f=;char ch=getchar();

     while(ch&lt;''||ch&gt;''){if(ch=='-')f=-;ch=getchar();}

     while(ch&gt;=''&amp;&amp;ch&lt;=''){x=*x+ch-'';ch=getchar();}

     return x*f;

 }<br />
 int n,mx,m,len,cnt,sum,tot,rt,rev[maxn],head[maxn],d[maxn],f[maxn],s[maxn],g[maxn];<br />
 bool del[maxn];<br />
 ll ret[maxn];<br />
 const double PI=acos(-1.0);<br />
 struct cp<br />
 {<br />
     double x,y;<br />
     cp operator +(cp b){return (cp){x+b.x,y+b.y};}<br />
     cp operator -(cp b){return (cp){x-b.x,y-b.y};}<br />
     cp operator *(cp b){return (cp){x*b.x-y*b.y,x*b.y+y*b.x};}<br />
 };<br />
 cp a[*maxn],b[*maxn],c[*maxn],y[*maxn];<br />
 struct edge{int go,next;}e[*maxn];<br />
 inline void insert(int x,int y)<br />
 {<br />
     e[++tot]=(edge){y,head[x]};head[x]=tot;<br />
     e[++tot]=(edge){x,head[y]};head[y]=tot;<br />
 }<br />
 inline void getrt(int x,int fa)<br />
 {<br />
     s[x]=;f[x]=;<br />
     for4(i,x)if(!del[y=e[i].go]&amp;&amp;y!=fa)<br />
     {<br />
         getrt(y,x);<br />
         s[x]+=s[y];<br />
         f[x]=max(f[x],s[y]);<br />
     }<br />
     f[x]=max(f[x],sum-f[x]);<br />
     if(f[x]&lt;f[rt])rt=x;<br />
 }<br />
 inline void getdep(int x,int fa,int w)<br />
 {<br />
     if(w&gt;mx)mx=w;<br />
     d[++cnt]=w;<br />
     for4(i,x)if(!del[y=e[i].go]&amp;&amp;y!=fa)getdep(y,x,w+);<br />
 }<br />
 inline void get(int n)<br />
 {<br />
     n++;n=*n-;<br />
     m=,len=;<br />
     while(m&lt;=n)m&lt;&lt;=,len++;<br />
     for0(i,m-)<br />
     {<br />
         int x=i,y=;<br />
         for1(j,len)y&lt;&lt;=,y|=x&amp;,x&gt;&gt;=;<br />
         rev[i]=y;<br />
     }<br />
 }<br />
 inline void fft(cp *x,int n,int flag)<br />
 {<br />
     for0(i,n-)y[rev[i]]=x[i];<br />
     for0(i,n-)x[i]=y[i];<br />
     for(int m=;m&lt;=n;m&lt;&lt;=)<br />
     {<br />
         cp wn=(cp){cos(2.0*PI*flag/m),sin(2.0*PI*flag/m)};<br />
         for(int i=;i&lt;n;i+=m)<br />
         {<br />
             cp w=(cp){,};int mid=m&gt;&gt;;<br />
             for0(j,mid-)<br />
             {<br />
                 cp u=x[i+j],v=x[i+j+mid]*w;<br />
                 x[i+j]=u+v;x[i+j+mid]=u-v;<br />
                 w=w*wn;<br />
             }<br />
         }<br />
     }<br />
     if(flag==-)for0(i,n-)x[i].x/=n;<br />
 }<br />
 inline void work(int x)<br />
 {<br />
     //cout&lt;&lt;"XXXXX"&lt;&lt;' '&lt;&lt;x&lt;&lt;' '&lt;&lt;"XXXX"&lt;&lt;endl;<br />
     del[x]=;mx=;<br />
     for4(i,x)if(!del[y=e[i].go])<br />
     {<br />
         cnt=;<br />
         getdep(y,x,);get(mx);<br />
         for0(j,m-)a[j]=(cp){g[j],},b[j]=(cp){,};<br />
         for1(j,cnt)b[d[j]].x+=,g[d[j]]++;<br />
         //for0(j,m-1)cout&lt;&lt;j&lt;&lt;' '&lt;&lt;a[j].x&lt;&lt;' '&lt;&lt;b[j].x&lt;&lt;endl;<br />
         fft(a,m,);fft(b,m,);<br />
         for0(j,m-)c[j]=a[j]*b[j];<br />
         fft(c,m,-);<br />
         for0(j,m-)ret[j]+=c[j].x+0.5;<br />
         //for0(j,m-1)cout&lt;&lt;j&lt;&lt;' '&lt;&lt;c[j].x&lt;&lt;' '&lt;&lt;c[j].y&lt;&lt;endl;<br />
     }<br />
     for1(i,mx)ret[i]+=g[i],g[i]=;<br />
     for4(i,x)if(!del[y=e[i].go])<br />
     {<br />
         sum=s[y];rt=;<br />
         getrt(y,);<br />
         work(rt);<br />
     }<br />
 }    

 int main()

 {

     freopen("input.txt","r",stdin);

     freopen("output.txt","w",stdout);

     n=read();<br />
     for1(i,n-)insert(read()+,read()+);<br />
     sum=n;f[rt=]=inf;<br />
     getrt(,);<br />
     work(rt);<br />
     double ans=0.0;<br />
     for1(i,n)<br />
     ans+=(double)ret[i]/(double)(i+);//cout&lt;&lt;i&lt;&lt;' '&lt;&lt;ret[i]&lt;&lt;endl;<br />
     printf("%.4f\n",n+*ans);

     return ;

 }  </pre>
</div>
</div>
<h2>3451: Tyvj1953 Normal</h2>
<p>Time Limit: 10 Sec&nbsp;&nbsp;Memory Limit: 128 MB<br />Submit: 125&nbsp;&nbsp;Solved: 60<br />[<a href="http://www.lydsy.com/JudgeOnline/submitpage.php?id=3451" rel="external nofollow noreferrer">Submit</a>][<a href="http://www.lydsy.com/JudgeOnline/problemstatus.php?id=3451" rel="external nofollow noreferrer">Status</a>]</p>
<h2>Description</h2>
<div>
<p>某天WJMZBMR学习了一个神奇的算法：树的点分治！<br />
这个算法的核心是这样的：<br />
消耗时间=0<br />
Solve(树 a)<br />
&nbsp;消耗时间 += a 的 大小<br />
&nbsp;如果 a 中 只有 1 个点<br />
&nbsp;&nbsp;退出<br />
&nbsp;否则在a中选一个点x，在a中删除点x<br />
&nbsp;那么a变成了几个小一点的树，对每个小树递归调用Solve<br />
我们注意到的这个算法的时间复杂度跟选择的点x是密切相关的。<br />
如果x是树的重心，那么时间复杂度就是O(nlogn)<br />
但是由于WJMZBMR比较傻逼，他决定随机在a中选择一个点作为x！<br />
Sevenkplus告诉他这样做的最坏复杂度是O(n^2)<br />
但是WJMZBMR就是不信&gt;_&lt;。。。<br />
于是Sevenkplus花了几分钟写了一个程序证明了这一点。。。你也试试看吧^_^<br />
现在给你一颗树，你能告诉WJMZBMR他的傻逼算法需要的期望消耗时间吗？（消耗时间按在Solve里面的那个为标准）</p>
</div>
<h2>Input</h2>
<div>
<p>第一行一个整数n，表示树的大小<br />
接下来n-1行每行两个数a,b，表示a和b之间有一条边<br />
注意点是从0开始标号的</p>
</div>
<h2>Output</h2>
<div>
<p>一行一个浮点数表示答案<br />
四舍五入到小数点后4位<br />
如果害怕精度跪建议用long double或者extended</p>
</div>
<h2>Sample Input</h2>
<div>3<br />
0 1<br />
1 2</div>
<h2>Sample Output</h2>
<div>5.6667</div>
<h2>HINT</h2>
<div>
<p>n&lt;=30000</p>
</div>
<h2>Source</h2>
<div>
<p><a href="http://www.lydsy.com/JudgeOnline/problemset.php?search=%E6%88%91%E4%BB%AC%E9%83%BD%E7%88%B1GYZ%E6%9D%AF" rel="external nofollow noreferrer">我们都爱GYZ杯</a></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kv00r9.html">sis9280触摸ic  基于rk3288 的安卓4&period;4的 多点触摸</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxjw4j9.html">二、获取微信用户openId</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv6j2o8.html">jenkins  publish over ssh使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okvzmp9.html">&period;NET企业轻量级开发框架（APS&period;NET&plus;Spring&period;Net&plus;NHibernate）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vk5go8.html">mvc5经典教程再补充。。</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok03np9.html">buptoj 1578</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn3k6j8.html">Javascript中的onclick事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jj35l8.html">Error Code&colon; 1318&period; Incorrect number of arguments for PROCEDURE company&period;new&lowbar;procedure&semi; expected 2&comma; got</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdmjxd9.html">ejabberd模块开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjnj6l8.html">zoj3778 Talented Chef</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1njooq.html">bug 对应</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj2z2e9.html">find命令总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eykozx9.html">python 单例模式获取IP代理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdkxoe9.html">Polar Code&lpar;1&rpar;极化码SC译码迭代公式的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5poprq.html">Vue&period;js常用指令：v-for</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw64nv9.html">vue-cil 中的配置分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnnmrxq.html">网易云信消息抄送服务的第三方接口示例（Java）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8komvj3q.html">django restframwork 教程之authentication权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn73jdq.html">String 在内存中如何存储的</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjyo668.html">PAT乙级1029</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4y7on0q.html">C&num; 将Datatable作为参数，传入存储过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x3z2g9.html">buffer busy wait在RAC环境下出现</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdn3v38.html">Maven使用本地jar包&lpar;小私服&quest;支持自动打入war包&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mny3y6q.html">IE9下Coolite&period;Ext出现createContextualFragment错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdn6jy8.html">高动态范围光照（High Dynamic Range Imaging，简称HDRI或HDR）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x353w9.html">Linux学习笔记（7）-系统资源查看</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok370p9.html">读书笔记 （二） &mdash;&mdash;&mdash;Fundamentals of Multiagent Systems with NetLogo Examples by Prof&period; Jose M Vidal</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdegm209.html">Delphi XE5  android   listview</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnyokrq.html">Spring MVC控制层的返回类型--String类型与Bean类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmzn649.html">js解决checkbox全选和反选的问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
